/***************************************************************************
                          qtrekodoc.cpp  -  description
                             -------------------
    begin                : Sun Aug 25 10:33:25 CEST 2002
    copyright            : (C) 2002 by kdereko@yahoo.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "qtrekodoc.h"
#include "reko.h"
#include <qstring.h>
#include <iostream.h>
#include <qdir.h>
#include <qfile.h>
#include <stdlib.h>
#include <qmessagebox.h>

QtRekoDoc::QtRekoDoc()
{
  modified = false;
  mDistort = false;
}

QtRekoDoc::~QtRekoDoc()
{
}

void QtRekoDoc::newDoc()
{
}

bool QtRekoDoc::save()
{
  return true;
}

bool QtRekoDoc::saveAs(const QString &filename)
{
  return true;
}

bool QtRekoDoc::load(const QString &filename)
{
  QString outname=filename;
  int pos=outname.findRev("/");
  QString dir = QString("");
  QString file = filename;
  QString realfilename = filename;
  QString ext;
  if (pos>=0)
  {
    dir = outname.left(pos);
    file = outname.right(outname.length()-pos-1);
  }

  cout << "Working directory: " << dir;

  pos = file.findRev(".");
  if (pos>=0)
  {
    ext = file.right(file.length()-pos-1);
    cout << "Extension: " << ext << endl;
    if (ext == QString("zip") || ext == QString("ZIP"))
    {
      QString cmd = QString("unzip -d %1 -o %2/%3").arg(dir).arg(dir).arg(file);
      cout << "Command " << cmd << endl;
      system(cmd.latin1());
      realfilename = dir+QString("/")+file.left(pos)+QString(".REKO");
      cout << "Checking " << realfilename << endl;
      QFile rfile(realfilename);
      if (! rfile.exists())
      {
        cout << "   " << realfilename << " does not exists ..." << endl;
        realfilename = dir+QString("/")+file.left(pos)+QString(".RKP");
      }
      cout << "Checking " << realfilename<< endl;
      rfile.setName(realfilename);
      if (! rfile.exists())
      {
        cout << "   " << realfilename << " does not exists ..."<< endl;
        cout << "Try manually extracting the archive and load the REKO file"<< endl;
        return true;
      }
    }
    file = file.left(pos);
  }


  // New dir
  dir = dir+QString("/cards-")+file;
  // Target name base
  outname = dir+QString("/");

  // Index file
  QString index = dir+QString("/index.desktop");


  cout << "infile: " << realfilename << endl;
  cout << "outfile:" << outname << endl;

  Reko reko;
  reko.makedir(dir);
  bool res=reko.convert(realfilename,outname,(int)(!mDistort));
  if (res)
  {
    reko.indexfile(index,file);
  }
  else
  {
    QMessageBox mb( "Error in conversion",
        "The conversion of the specified file did not work\n",
        QMessageBox::Warning,
        QMessageBox::Ok | QMessageBox::Default,
        0,
        0 );
   mb.exec();
  }

  emit documentChanged();

  return true;
}

bool QtRekoDoc::isModified() const
{
  return modified;
}
/** No descriptions */
void QtRekoDoc::distortion(bool flag){
  mDistort = flag;
}
